/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: dp_servicefactory.h,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 17:19:27 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#if ! defined INCLUDED_DP_SERVICEFACTORY_H
#define INCLUDED_DP_SERVICEFACTORY_H

#include "cppuhelper/factory.hxx"


namespace css = ::com::sun::star;

namespace dp_misc
{

typedef css::uno::Reference<css::uno::XInterface> (SAL_CALL * fptr_create)(
    css::uno::Sequence<css::uno::Any> const & args,
    css::uno::Reference<css::uno::XComponentContext> const & xContext );

//==============================================================================
css::uno::Reference<css::lang::XSingleComponentFactory> SAL_CALL createFactory(
    /* fptr_create */ ::cppu::ComponentFactoryFunc fptr,
    ::rtl::OUString const & implName,
    css::uno::Sequence< ::rtl::OUString > const & supportedServices,
    rtl_ModuleCount * );

}

#endif
