#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.12 $
#
#   last change: $Author: rt $ $Date: 2005/09/07 20:18:01 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

PRJ		= ..$/..
PRJNAME = oosupport
PACKAGE = org$/netbeans$/modules$/openoffice
TARGET  = org_netbeans_modules_openoffice
#JARPATH = $(CLASSDIR)$/..$/bin
JARPATH = $(SOLARBINDIR)
JARCOMMONPATH = $(SOLARCOMMONBINDIR)

# --- Settings -----------------------------------------------------

.INCLUDE : settings.mk

.IF "$(SOLAR_JAVA)"==""
nojava:
	@echo "Not building odk/source/OOSupport because Java has been disabled"
.ENDIF
.IF "$(OS)"=="MACOSX"
dummy:
	@echo "Nothing to build for OS $(OS)"
.ENDIF

# Files --------------------------------------------------------

JARFILES                = $(JARPATH)$/ridl.jar$(PATH_SEPERATOR)$(JARPATH)$/juh.jar$(PATH_SEPERATOR)$(JARPATH)$/jurt.jar$(PATH_SEPERATOR)$(JARCOMMONPATH)$/jarpackager.jar$(PATH_SEPERATOR)$(JARCOMMONPATH)$/openide.jar$(PATH_SEPERATOR)$(JARPATH)$/jakarta-regexp-1.2.jar$(PATH_SEPERATOR)$(JARCOMMONPATH)$/nbantext.jar$(PATH_SEPERATOR)$(JARCOMMONPATH)$/jhall.jar

JAVACLASSFILES               = $(subst,$(CLASSDIR)$/, $(shell $(FIND) $(CLASSDIR)$/org$/netbeans$/modules$/openoffice -name *.class) )

JAVAFILES               = \
	$(PACKAGE)$/InstallationPanel.java	\
	$(PACKAGE)$/OOExtensionFilter.java	\
	$(PACKAGE)$/OOIDLCompiler.java	\
	$(PACKAGE)$/OOIDLCompilerGroup.java	\
	$(PACKAGE)$/OOIDLCompilerType.java	\
	$(PACKAGE)$/OOIDLCompilerTypeBeanInfo.java	\
	$(PACKAGE)$/OOIDLDataLoader.java	\
	$(PACKAGE)$/OOIDLDataObject.java	\
	$(PACKAGE)$/OOIDLGlobalSettings.java	\
	$(PACKAGE)$/OOIDLGlobalSettingsBeanInfo.java	\
	$(PACKAGE)$/OOIDLInstaller.java	\
	$(PACKAGE)$/OOREGCompiler.java	\
	$(PACKAGE)$/OOREGCompilerGroup.java	\
	$(PACKAGE)$/OOREGCompilerType.java	\
	$(PACKAGE)$/OOREGCompilerTypeBeanInfo.java	\
	$(PACKAGE)$/OOTools.java	\
	$(PACKAGE)$/OOURDCleanCompiler.java	\
	$(PACKAGE)$/OOURDCleanCompilerGroup.java	\
	$(PACKAGE)$/OOURDCompiler.java	\
	$(PACKAGE)$/OOURDCompilerGroup.java	\
	$(PACKAGE)$/OOURDCompilerType.java	\
	$(PACKAGE)$/OOURDCompilerTypeBeanInfo.java	\
	$(PACKAGE)$/OOURDDataLoader.java	\
	$(PACKAGE)$/OOURDDataLoaderBeanInfo.java	\
	$(PACKAGE)$/OOURDDataObject.java	\
	$(PACKAGE)$/wizard$/IDLInterface.java	\
	$(PACKAGE)$/wizard$/IDLMethod.java	\
	$(PACKAGE)$/wizard$/IDLParameter.java	\
	$(PACKAGE)$/wizard$/OOAddInCreateIterator.java	\
	$(PACKAGE)$/wizard$/OOAddinData.java	\
	$(PACKAGE)$/wizard$/OOIDLData.java	\
	$(PACKAGE)$/wizard$/OOIDLWizardIterator.java	\
	$(PACKAGE)$/wizard$/OOServiceCreateIterator.java	\
	$(PACKAGE)$/wizard$/OOServiceData.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateAliasAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateAttributeAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateConstantAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateConstantsAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateEnumAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateEnumEntryAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateExceptionAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateFwdDclAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateInterfaceAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateModuleAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateOperationAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateServiceAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateStructAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateStructMemberAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateUnionAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateUnionDefaultAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateUnionMemberAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateValueBoxAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/CreateValueTypeAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/DestroyAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/EditAction.java	\
	$(PACKAGE)$/wizard$/actions$/idl$/RenameAction.java	\
	$(PACKAGE)$/wizard$/keys$/AliasKey.java	\
	$(PACKAGE)$/wizard$/keys$/AttributeKey.java	\
	$(PACKAGE)$/wizard$/keys$/BaseKey.java	\
	$(PACKAGE)$/wizard$/keys$/ConstKey.java	\
	$(PACKAGE)$/wizard$/keys$/EnumKey.java	\
	$(PACKAGE)$/wizard$/keys$/ForwardDclKey.java	\
	$(PACKAGE)$/wizard$/keys$/InterfaceKey.java	\
	$(PACKAGE)$/wizard$/keys$/NameKey.java	\
	$(PACKAGE)$/wizard$/keys$/OperationKey.java	\
	$(PACKAGE)$/wizard$/keys$/StructKey.java	\
	$(PACKAGE)$/wizard$/keys$/UnionMemberKey.java	\
	$(PACKAGE)$/wizard$/keys$/ValueFactoryKey.java	\
	$(PACKAGE)$/wizard$/keys$/ValueKey.java	\
	$(PACKAGE)$/wizard$/nodes$/AliasNode.java	\
	$(PACKAGE)$/wizard$/nodes$/AttributeNode.java	\
	$(PACKAGE)$/wizard$/nodes$/BaseNode.java	\
	$(PACKAGE)$/wizard$/nodes$/ConstantNode.java	\
	$(PACKAGE)$/wizard$/nodes$/ConstantsNode.java	\
	$(PACKAGE)$/wizard$/nodes$/EnumEntryNode.java	\
	$(PACKAGE)$/wizard$/nodes$/EnumNode.java	\
	$(PACKAGE)$/wizard$/nodes$/ExceptionNode.java	\
	$(PACKAGE)$/wizard$/nodes$/ForwardDcl.java	\
	$(PACKAGE)$/wizard$/nodes$/IDLBaseChildren.java	\
	$(PACKAGE)$/wizard$/nodes$/IdlFileNode.java	\
	$(PACKAGE)$/wizard$/nodes$/InterfaceNode.java	\
	$(PACKAGE)$/wizard$/nodes$/LeafNode.java	\
	$(PACKAGE)$/wizard$/nodes$/ModuleNode.java	\
	$(PACKAGE)$/wizard$/nodes$/MovableNode.java	\
	$(PACKAGE)$/wizard$/nodes$/OperationNode.java	\
	$(PACKAGE)$/wizard$/nodes$/SENode.java	\
	$(PACKAGE)$/wizard$/nodes$/ServiceNode.java	\
	$(PACKAGE)$/wizard$/nodes$/StructMemberNode.java	\
	$(PACKAGE)$/wizard$/nodes$/StructNode.java	\
	$(PACKAGE)$/wizard$/nodes$/UnionMemberNode.java	\
	$(PACKAGE)$/wizard$/nodes$/UnionNode.java	\
	$(PACKAGE)$/wizard$/nodes$/ValueBoxNode.java	\
	$(PACKAGE)$/wizard$/nodes$/ValueNode.java	\
	$(PACKAGE)$/wizard$/panels$/addin$/MethodDescriptionPanel.java	\
	$(PACKAGE)$/wizard$/panels$/service$/IDLFilter.java	\
	$(PACKAGE)$/wizard$/panels$/service$/InterfacePickUp.java	\
	$(PACKAGE)$/wizard$/panels$/service$/LanguageSelectionPanel.java	\
	$(PACKAGE)$/wizard$/panels$/service$/NewTypesPanel.java	\
	$(PACKAGE)$/wizard$/panels$/service$/OOInterfacePanel.java	\
	$(PACKAGE)$/wizard$/panels$/service$/OOServiceClassPanel.java	\
	$(PACKAGE)$/wizard$/panels$/service$/ServiceSelectionPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/AliasPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/AttributePanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/BasePanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/ConstantsPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/ConstPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/CreateIDLPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/EnumPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/ForwardDclPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/InterfacePanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/ModuleCreatePanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/OperationPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/UnionMemberPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/UnionPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/ValueBoxPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/ValueFactoryPanel.java	\
	$(PACKAGE)$/wizard$/panels$/idl$/ValuePanel.java	\
	$(PACKAGE)$/wizard$/util$/AbstractMoveableNode.java	\
	$(PACKAGE)$/wizard$/util$/AliasCreator.java	\
	$(PACKAGE)$/wizard$/util$/AttributeCreator.java	\
	$(PACKAGE)$/wizard$/util$/ConstantCreator.java	\
	$(PACKAGE)$/wizard$/util$/ConstantsCreator.java	\
	$(PACKAGE)$/wizard$/util$/Create.java	\
	$(PACKAGE)$/wizard$/util$/EditCookie.java	\
	$(PACKAGE)$/wizard$/util$/EnumCreator.java	\
	$(PACKAGE)$/wizard$/util$/EnumEntryCreator.java	\
	$(PACKAGE)$/wizard$/util$/ExceptionCreator.java	\
	$(PACKAGE)$/wizard$/util$/FwdDclCreator.java	\
	$(PACKAGE)$/wizard$/util$/InterfaceCreator.java	\
	$(PACKAGE)$/wizard$/util$/ModuleCreator.java	\
	$(PACKAGE)$/wizard$/util$/OOIDLParser.java	\
	$(PACKAGE)$/wizard$/util$/OperationCreator.java	\
	$(PACKAGE)$/wizard$/util$/ServiceCreator.java	\
	$(PACKAGE)$/wizard$/util$/StructCreator.java	\
	$(PACKAGE)$/wizard$/util$/StructMemberCreator.java	\
	$(PACKAGE)$/wizard$/util$/UnionCreator.java	\
	$(PACKAGE)$/wizard$/util$/UnionDefaultCreator.java	\
	$(PACKAGE)$/wizard$/util$/UnionMemberCreator.java	\
	$(PACKAGE)$/wizard$/util$/ValueBoxCreator.java	\
	$(PACKAGE)$/wizard$/util$/ValueCreator.java	\
	$(PACKAGE)$/wizard$/util$/ValueTypeCreator.java	\
	MakeModule.java

ADDITIONALFILES               = \
	$(PACKAGE)$/Bundle.properties	\
	$(PACKAGE)$/Bundle_de.properties	\
	$(PACKAGE)$/Global.gif	\
	$(PACKAGE)$/idl-error.gif	\
	$(PACKAGE)$/idl.gif	\
	$(PACKAGE)$/idl32.gif	\
	$(PACKAGE)$/layer.xml	\
	$(PACKAGE)$/urd.gif	\
	$(PACKAGE)$/help$/help-contents.xml	\
	$(PACKAGE)$/help$/help-set.xml	\
	$(PACKAGE)$/help$/help-map.xml	\
	$(PACKAGE)$/help$/help-main-page.xml	\
	$(PACKAGE)$/help$/help-set-ref.xml	\
	$(PACKAGE)$/help$/ModuleDataIcon.gif	\
	$(PACKAGE)$/help$/credits.html	\
	$(PACKAGE)$/help$/ide.css	\
	$(PACKAGE)$/help$/idl.html	\
	$(PACKAGE)$/help$/intro.html	\
	$(PACKAGE)$/help$/AdditionalResources$/AdditionalResources.html	\
	$(PACKAGE)$/help$/CodeCompletion$/CodeCompletion.html	\
	$(PACKAGE)$/help$/CodeCompletion$/JavaCodeCompletion.gif	\
	$(PACKAGE)$/help$/Debugging$/AttachToVM.jpg	\
	$(PACKAGE)$/help$/Debugging$/Debugging.html	\
	$(PACKAGE)$/help$/DisplayingReference$/APIHelp.gif	\
	$(PACKAGE)$/help$/DisplayingReference$/DisplayingReference.html	\
	$(PACKAGE)$/help$/FundamentalConcepts$/API.html	\
	$(PACKAGE)$/help$/FundamentalConcepts$/FundamentalConcepts.html	\
	$(PACKAGE)$/help$/FundamentalConcepts$/UniversalNetworkObjects.html	\
	$(PACKAGE)$/help$/GlobalSettings$/GlobalSettings.html	\
	$(PACKAGE)$/help$/HelperClasses$/database.html	\
	$(PACKAGE)$/help$/HelperClasses$/helper.html	\
	$(PACKAGE)$/help$/JavaHelpSearch$/DOCS	\
	$(PACKAGE)$/help$/JavaHelpSearch$/DOCS.TAB	\
	$(PACKAGE)$/help$/JavaHelpSearch$/OFFSETS	\
	$(PACKAGE)$/help$/JavaHelpSearch$/POSITIONS	\
	$(PACKAGE)$/help$/JavaHelpSearch$/SCHEMA	\
	$(PACKAGE)$/help$/JavaHelpSearch$/TMAP	\
	$(PACKAGE)$/help$/Templates$/calcaddin.html	\
	$(PACKAGE)$/help$/Templates$/service.html	\
	$(PACKAGE)$/help$/Templates$/templates.html	\
	$(PACKAGE)$/help$/Tools$/cppumaker.html	\
	$(PACKAGE)$/help$/Tools$/cunomaker.html	\
	$(PACKAGE)$/help$/Tools$/idlc.html	\
	$(PACKAGE)$/help$/Tools$/javamaker.html	\
	$(PACKAGE)$/help$/Tools$/rdbmaker.html	\
	$(PACKAGE)$/help$/Tools$/regcomp.html	\
	$(PACKAGE)$/help$/Tools$/regmerge.html	\
	$(PACKAGE)$/help$/Tools$/regview.html	\
	$(PACKAGE)$/help$/Tools$/uno.html	\
	$(PACKAGE)$/help$/Tools$/util.html	\
	$(PACKAGE)$/help$/Tools$/xml2cmp.html	\
	$(PACKAGE)$/help$/WritingComponents$/AccessingServices.html	\
	$(PACKAGE)$/help$/WritingComponents$/DescribingServices.html	\
	$(PACKAGE)$/help$/WritingComponents$/ImplementingServices.html	\
	$(PACKAGE)$/help$/WritingComponents$/RegisteringServices.html	\
	$(PACKAGE)$/help$/WritingComponents$/ServicesInterfacesProperties.html	\
	$(PACKAGE)$/help$/WritingComponents$/WritingComponents.html	\
	$(PACKAGE)$/help$/WritingComponents$/servicesandinterfaces.gif	\
	$(PACKAGE)$/wizard$/Bundle.properties	\
	$(PACKAGE)$/wizard$/CalcAddIn.html	\
	$(PACKAGE)$/wizard$/IDLEmpty.html	\
	$(PACKAGE)$/wizard$/MinimalComponent.html	\
	$(PACKAGE)$/wizard$/ODK.html	\
	$(PACKAGE)$/wizard$/actions$/idl$/Bundle.properties	\
	$(PACKAGE)$/wizard$/nodes$/Bundle.properties	\
	$(PACKAGE)$/wizard$/panels$/addin$/Bundle.properties	\
	$(PACKAGE)$/wizard$/panels$/idl$/Bundle.properties	\
	$(PACKAGE)$/wizard$/panels$/service$/Bundle.properties	\
	$(PACKAGE)$/wizard$/panels$/service$/BundleLanguageSelection.properties	\
	$(PACKAGE)$/wizard$/panels$/service$/BundleServiceSelection.properties	\
	$(PACKAGE)$/wizard$/templates$/CalcAddins.template	\
	$(PACKAGE)$/wizard$/templates$/idl.template	\
	$(PACKAGE)$/wizard$/templates$/service.template	\
	$(PACKAGE)$/wizard$/ui$/attribute.gif	\
	$(PACKAGE)$/wizard$/ui$/const.gif	\
	$(PACKAGE)$/wizard$/ui$/constants.gif	\
	$(PACKAGE)$/wizard$/ui$/declarator.gif	\
	$(PACKAGE)$/wizard$/ui$/enum.gif	\
	$(PACKAGE)$/wizard$/ui$/exception.gif	\
	$(PACKAGE)$/wizard$/ui$/factory.gif	\
	$(PACKAGE)$/wizard$/ui$/idl.gif	\
	$(PACKAGE)$/wizard$/ui$/idl32.gif	\
	$(PACKAGE)$/wizard$/ui$/interface.gif	\
	$(PACKAGE)$/wizard$/ui$/module.gif	\
	$(PACKAGE)$/wizard$/ui$/operation.gif	\
	$(PACKAGE)$/wizard$/ui$/service.gif	\
	$(PACKAGE)$/wizard$/ui$/state_member.gif	\
	$(PACKAGE)$/wizard$/ui$/struct.gif	\
	$(PACKAGE)$/wizard$/ui$/type.gif	\
	$(PACKAGE)$/wizard$/ui$/union.gif	\
	$(PACKAGE)$/wizard$/ui$/unionmember.gif	\
	$(PACKAGE)$/wizard$/ui$/value.gif


MANIFESTFILE = manifest.mf

TARGETJARFILE   = oosupport.jar

TARGETNETBEANSMODULEFILE	= oosupport.nbm

# --- Targets ------------------------------------------------------

all : 	\
    $(CLASSDIR)$/$(TARGETNETBEANSMODULEFILE)

$(CLASSDIR)$/$(TARGETNETBEANSMODULEFILE): $(JAVAFILES)
	$(JAVAC) $(JAVACPS) $(CLASSPATH)$(PATH_SEPERATOR)$(JARFILES) -d $(CLASSDIR) $(JAVAFLAGS) $(JAVAFILES)
	jar -cvfm $(CLASSDIR)$/$(TARGETJARFILE) $(MANIFESTFILE) $(ADDITIONALFILES)
	+cd $(CLASSDIR) && jar -uvf $(TARGETJARFILE) org$/
	+-mkdir $(CLASSDIR)$/netbeans
	+-mkdir $(CLASSDIR)$/netbeans$/system
	+cp -R ParserDB $(CLASSDIR)$/netbeans$/system
	+cp openoffice-nbm-license.txt $(CLASSDIR)
	+-mkdir $(CLASSDIR)$/netbeans$/modules
	+cd $(CLASSDIR) && cp oosupport.jar netbeans$/modules && $(WRAPCMD) java -classpath $(CLASSPATH) MakeModule
	+cd $(CLASSDIR) && jar -uvf $(TARGETNETBEANSMODULEFILE) netbeans
