
package org.netbeans.modules.openoffice;

import org.openide.compiler.ExternalCompiler;
import org.openide.execution.NbProcessDescriptor;
import org.openide.filesystems.FileObject;

/**
 *
 * @author  Michael Bohn
 *
 */


public class OOIDLCompiler extends ExternalCompiler {

   public OOIDLCompiler (FileObject fo, NbProcessDescriptor proc, ExternalCompiler.ErrorExpression err ) {
     
        super (fo, BUILD, proc, err);
        
    } 
    /** Get the compiler group class to use.
     * @return the class
     */
    public Class compilerGroupClass () {
        return OOIDLCompilerGroup.class;
    }

   
    public boolean isUpToDate () {
        return false;
    }

    /** One key per compiler.
     */
    private Object key = new Object ();
    /** Get the grouping key.
     * In this case, constant per compiler,
     * since these should never be grouped together.
     * @return the constant key
     */
   
  public Object compilerGroupKey () {
        // Note: do not use 'this' as that causes a cycle in equals()
        return key;
    }

    /** Test for compiler equality.
     * @param o compiler to test against
     * @return <CODE>true</CODE> if equivalent
     */
    public boolean equals (Object o) {
        if (! (o instanceof OOIDLCompiler)) return false;
        if (! super.equals (o)) return false;
        return true;
    }

    /** Get the compiler hash code.
     * @return a computed hash
     */
    public int hashCode () {
        return super.hashCode ();
    }

}
