#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: tg_srs.mk,v $
#
#   $Revision: 1.19 $
#
#   last change: $Author: rt $ $Date: 2005/09/08 09:49:36 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************


.IF "$(MULTI_SRC_FLAG)"==""

SRC1 ?= TNR!:=1
$(SRC1TARGET) .NULL : SRC1

SRC2 ?= TNR!:=2
$(SRC2TARGET) .NULL : SRC2

SRC3 ?= TNR!:=3
$(SRC3TARGET) .NULL : SRC3

SRC4 ?= TNR!:=4
$(SRC4TARGET) .NULL : SRC4

SRC5 ?= TNR!:=5
$(SRC5TARGET) .NULL : SRC5

SRC6 ?= TNR!:=6
$(SRC6TARGET) .NULL : SRC6

SRC7 ?= TNR!:=7
$(SRC7TARGET) .NULL : SRC7

SRC8 ?= TNR!:=8
$(SRC8TARGET) .NULL : SRC8

SRC9 ?= TNR!:=9
$(SRC9TARGET) .NULL : SRC9

# -----------------

DEPSRS1 ?= TNR!:=1
$(DEPSRS1FILE) .NULL : DEPSRS1

DEPSRS2 ?= TNR!:=2
$(DEPSRS2FILE) .NULL : DEPSRS2

DEPSRS3 ?= TNR!:=3
$(DEPSRS3FILE) .NULL : DEPSRS3

DEPSRS4 ?= TNR!:=4
$(DEPSRS4FILE) .NULL : DEPSRS4

DEPSRS5 ?= TNR!:=5
$(DEPSRS5FILE) .NULL : DEPSRS5

DEPSRS6 ?= TNR!:=6
$(DEPSRS6FILE) .NULL : DEPSRS6

DEPSRS7 ?= TNR!:=7
$(DEPSRS7FILE) .NULL : DEPSRS7

DEPSRS8 ?= TNR!:=8
$(DEPSRS8FILE) .NULL : DEPSRS8

DEPSRS9 ?= TNR!:=9
$(DEPSRS9FILE) .NULL : DEPSRS9

.ENDIF

.IF "$(MULTI_SRC_FLAG)" == ""
SRC1 SRC2 SRC3 SRC4 SRC5 SRC6 SRC7 SRC8 SRC9:
	@+dmake $(SRS)$/$(SRS$(TNR)NAME).srs MULTI_SRC_FLAG=true TNR:=$(TNR) $(MFLAGS) $(CALLMACROS)

DEPSRS1 DEPSRS2 DEPSRS3 DEPSRS4 DEPSRS5 DEPSRS6 DEPSRS7 DEPSRS8 DEPSRS9:
	@+dmake $(DEPSRS$(TNR)FILE) MULTI_SRC_FLAG=true TNR:=$(TNR) $(MFLAGS) $(CALLMACROS)
.ELSE

#######################################################
# unroll begin

.IF "$(SRS$(TNR)NAME)"!=""
.IF "$(BUILDHIDS)"!=""
HID$(TNR)FILES=$(foreach,i,$(SRC$(TNR)FILES:f) $(SRS)$/$(i:s/.src/.hid/))
HIDSRS$(TNR)PARTICLE=$(subst,$(OUTPATH),$(COMMON_OUTDIR) $(SRS))$/$(SRS$(TNR)NAME)_srs.hid
$(HIDSRS$(TNR)PARTICLE) : $(HID$(TNR)FILES)
    @echo ------------------------------
    @echo Making: $@
    @+-$(RM) $@
    +$(TYPE) $(mktmp  $(subst,$/,/ $(HID$(TNR)FILES))) | xargs -s 1000 cat > $@.$(ROUT).tmp
    @+$(RENAME) $@.$(ROUT).tmp $@

ALLTAR : $(HIDSRS$(TNR)PARTICLE)

.ENDIF # "$(BUILDHIDS)"!=""

$(MISC)$/$(PWD:f).$(SRS$(TNR)NAME).dprr: $(SRC$(TNR)FILES) $(HIDSRS$(TNR)PARTICLE) $(HID$(TNR)FILES)
	@echo ------------------------------
	@echo Making: $@
	+-$(RM) $(MISC)$/$(PWD:f).$(SRS$(TNR)NAME).dprr >& $(NULLDEV)
	+$(RSC) $(SRSDEFAULT) $(RSC_SRS_CHARSET) $(RSCFLAGS) -I$(RSCEXTINC) -I$(INCLOCPRJ)  -I$(INCLOCAL) -I$(INC) -I$(INCCOM) $(RSCDEFS) $(RSCUPDVERDEF) -fp={$(SRS)$/$(SRS$(TNR)NAME).srs} -fo=$@ $(SRC$(TNR)FILES)

$(foreach,i,$(SRC$(TNR)FILES) $(COMMONMISC)$/$(TARGET)$/$i) : $$(@:f) localize.sdf 
    +-$(MKDIR) $(@:d)
    +-$(RM) $@
    $(WRAPCMD) $(TRANSEX) -p $(PRJNAME) -i $(@:f) -o $(@).$(INPATH) -m localize.sdf -l all
    +$(RENAME) $@.$(INPATH) $@
    +-$(RM) $@.$(INPATH)

$(SRS)$/$(SRS$(TNR)NAME).srs: $(foreach,i,$(SRC$(TNR)FILES) $(COMMONMISC)$/$(TARGET)$/$i)
	@echo ------------------------------
	@echo Making: $@
	+$(RSC) -presponse @$(mktmp \
		$(SRSDEFAULT) $(RSC_SRS_CHARSET) $(RSCFLAGS) -I$(RSCEXTINC) \
		$(INCLUDE) $(RSCDEFS) $(RSCUPDVERDEF) \
		-fp=$@.$(INPATH) \
		$(foreach,i,$(SRC$(TNR)FILES) $(COMMONMISC)$/$(TARGET)$/$i) \
	)
	+-$(RM) $@
	+$(RENAME) $@.$(INPATH) $@
	+-$(RM) $@.$(INPATH)

.ENDIF          # "$(SRS$(TNR)NAME)"!=""

# unroll end
#######################################################

.ENDIF          # "$(MULTI_SRC_FLAG)"==""


