/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: svdsuro.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 00:40:35 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#include "svdsuro.hxx"
//BFS01#include "svdobj.hxx"
//BFS01#include "svdpage.hxx"
//BFS01#include "svdmodel.hxx"

//BFS01#ifndef _TOOLS_DEBUG_HXX //autogen
//BFS01#include <tools/debug.hxx>
//BFS01#endif

////////////////////////////////////////////////////////////////////////////////////////////////////

// fuer Schreiben
//BFS01SdrObjSurrogate::SdrObjSurrogate(SdrObject* pObj1, const SdrObject* pRefObj1)
//BFS01{
//BFS01	ImpClearVars();
//BFS01	pObj=pObj1;
//BFS01	pRefObj=pRefObj1;
//BFS01	ImpMakeSurrogate();
//BFS01}

// fuer Lesen
//BFS01SdrObjSurrogate::SdrObjSurrogate(const SdrModel& rMod, SvStream& rIn)
//BFS01{
//BFS01	ImpClearVars();
//BFS01	pModel=&rMod;
//BFS01	ImpRead(rIn);
//BFS01}

// fuer Lesen
//BFS01SdrObjSurrogate::SdrObjSurrogate(const SdrObject& rRefObj, SvStream& rIn)
//BFS01{
//BFS01	ImpClearVars();
//BFS01	pRefObj=&rRefObj;
//BFS01	pModel=rRefObj.GetModel();
//BFS01	ImpRead(rIn);
//BFS01}

//BFS01SdrObjSurrogate::~SdrObjSurrogate()
//BFS01{
//BFS01	if (pGrpOrdNums!=NULL) delete [] pGrpOrdNums;
//BFS01}

//BFS01void SdrObjSurrogate::ImpClearVars()
//BFS01{
//BFS01	pObj=NULL;
//BFS01	pRefObj=NULL;
//BFS01	pList=NULL;
//BFS01	pRootList=NULL;
//BFS01	pPage=NULL;
//BFS01	pModel=NULL;
//BFS01	eList=SDROBJLIST_UNKNOWN;
//BFS01	nOrdNum=0;
//BFS01	pGrpOrdNums=NULL;
//BFS01	nGrpLevel=0;
//BFS01	nPageNum=0;
//BFS01}

//BFS01void SdrObjSurrogate::ImpMakeSurrogate()
//BFS01{
//BFS01	if (pObj!=NULL) { // ansonsten bleibt eList=SDROBJLIST_UNKNOWN, weil Obj=NULL
//BFS01		FASTBOOL bSameList=FALSE;
//BFS01		FASTBOOL bSamePage=FALSE;
//BFS01		pModel=pObj->GetModel();
//BFS01		pList=pObj->GetObjList();
//BFS01		pRootList=pList;
//BFS01		pPage=pObj->GetPage();
//BFS01		nOrdNum=pObj->GetOrdNum();
//BFS01		DBG_ASSERT(pModel!=NULL,"ImpMakeSurrogate(): Zielobjekt hat kein Model");
//BFS01		DBG_ASSERT(pList!=NULL,"ImpMakeSurrogate(): Zielobjekt hat keine ObjList");
//BFS01		if (pModel!=NULL && pList!=NULL) {
//BFS01			if (pRefObj!=NULL) {
//BFS01				if (pList==pRefObj->GetObjList()) bSameList=TRUE;
//BFS01				else if (pPage!=NULL && pPage==pRefObj->GetPage()) bSamePage=TRUE;
//BFS01			}
//BFS01			if (!bSameList) {
//BFS01				//if (eList==SDROBJLIST_UNKNOWN) eList=pList->GetListKind();
//BFS01				SdrObjList* pL=pList->GetUpList();
//BFS01				nGrpLevel=0;
//BFS01				while (pL!=NULL) { pL=pL->GetUpList(); nGrpLevel++; }
//BFS01				if (nGrpLevel!=0) { // Aha, verschachtelt
//BFS01					pGrpOrdNums=new UINT32[nGrpLevel];
//BFS01					const SdrObjList* pL=pRootList;
//BFS01					for (unsigned i=nGrpLevel; i>0;) {
//BFS01						i--;
//BFS01						SdrObject* pGrp=pL->GetOwnerObj();
//BFS01						if (pGrp!=NULL && pL->GetListKind()==SDROBJLIST_GROUPOBJ && pGrp->GetObjList()==pL->GetUpList() && pGrp->GetSubList()==pL) {
//BFS01							pGrpOrdNums[i]=pGrp->GetOrdNum();
//BFS01						} else { // sonst Fehlerhafte Verkettung
//BFS01#ifdef DBG_UTIL
//BFS01							ByteString aStr("ImpMakeSurrogate() - Inkonsistente Verkettung:\n");
//BFS01							String aStr1;
//BFS01							
//BFS01							pObj->TakeObjNameSingul(aStr1);
//BFS01							
//BFS01							aStr += "Schleifendurchlauf="; 
//BFS01							aStr += ByteString::CreateFromInt32( i );
//BFS01							aStr += " GroupingLevel="; 
//BFS01							aStr += ByteString::CreateFromInt32( nGrpLevel );
//BFS01							aStr += " Ordnumgszahl="; 
//BFS01							aStr += ByteString::CreateFromInt32( pObj->GetOrdNum() );
//BFS01							aStr += "\nObjektbezeichnung='"; 
//BFS01							aStr += ByteString(aStr1, gsl_getSystemTextEncoding()); 
//BFS01							aStr += "'\n";
//BFS01
//BFS01							if(pGrp) 
//BFS01								aStr += "\n- Liste mit Parent hat kein OwnerObj.";
//BFS01							
//BFS01							if(pL->GetListKind()==SDROBJLIST_GROUPOBJ) 
//BFS01								aStr += "\n- Liste mit Parent liefert ListKind!=SDROBJLIST_GROUPOBJ.";
//BFS01
//BFS01							if(pGrp && pGrp->GetObjList() == pL->GetUpList()) 
//BFS01								aStr += "\n- ObjList des OwnerObj und ParentList seiner SubList sind nicht identisch.";
//BFS01
//BFS01							if(pGrp && pGrp->GetSubList() == pL) 
//BFS01								aStr += "\n- Sublist des OwnerObj des OwnerObj entspricht nicht der Liste selbst.";
//BFS01
//BFS01							DBG_ERROR(aStr.GetBuffer());
//BFS01#endif
//BFS01							delete [] pGrpOrdNums;
//BFS01							pGrpOrdNums=NULL;
//BFS01							nGrpLevel=0;
//BFS01							return;
//BFS01						}
//BFS01						pL=pL->GetUpList();
//BFS01					}
//BFS01					pRootList=pL;
//BFS01					if (pL==NULL || pL->GetUpList()!=NULL || pL->GetOwnerObj()!=NULL || pL->GetListKind()==SDROBJLIST_GROUPOBJ) {
//BFS01						delete [] pGrpOrdNums;
//BFS01						pGrpOrdNums=NULL;
//BFS01						nGrpLevel=0;
//BFS01						return;
//BFS01					}
//BFS01				} // if (nGrpLevel!=0)
//BFS01			} // if (eList!=SDROBJLIST_SAMELIST)
//BFS01			if (bSameList) eList=SDROBJLIST_SAMELIST;
//BFS01			else if (bSamePage) eList=SDROBJLIST_SAMEPAGE;
//BFS01			else eList=pRootList->GetListKind();
//BFS01			if (eList==SDROBJLIST_GROUPOBJ || eList==SDROBJLIST_UNKNOWN) {
//BFS01				if (pGrpOrdNums!=NULL) {
//BFS01					delete [] pGrpOrdNums;
//BFS01					pGrpOrdNums=NULL;
//BFS01					nGrpLevel=0;
//BFS01				}
//BFS01				eList=SDROBJLIST_UNKNOWN;
//BFS01				return;
//BFS01			}
//BFS01			if (SdrIsPageKind(eList)) {
//BFS01				if (pPage!=NULL) {
//BFS01					nPageNum=pPage->GetPageNum();
//BFS01				} else {
//BFS01					DBG_ERROR("ImpMakeSurrogate(): eList ist eine Page, aber pPage==NULL");
//BFS01					if (pGrpOrdNums!=NULL) {
//BFS01						delete [] pGrpOrdNums;
//BFS01						pGrpOrdNums=NULL;
//BFS01						nGrpLevel=0;
//BFS01					}
//BFS01					eList=SDROBJLIST_UNKNOWN;
//BFS01					return;
//BFS01				}
//BFS01			}
//BFS01			// so, nun ist alles beisammen und kann gestreamt werden.
//BFS01		} // if (pModel!=NULL && pList!=NULL)
//BFS01	} // if (pObj!=NULL)
//BFS01}

//BFS01void SdrObjSurrogate::ImpWriteValue(SvStream& rOut, UINT32 nVal, unsigned nByteAnz) const
//BFS01{
//BFS01	switch (nByteAnz) {
//BFS01		case 0: rOut<<BYTE(nVal);   break;
//BFS01		case 1: rOut<<UINT16(nVal); break;
//BFS01		case 3: rOut<<nVal;         break;
//BFS01		default: DBG_ERROR("ImpWriteValue(): Nur Bytelaengen 1, 2 oder 4 sind erlaubt!");
//BFS01	} // switch
//BFS01}

//BFS01void SdrObjSurrogate::ImpReadValue(SvStream& rIn, UINT32& rVal, unsigned nByteAnz) const
//BFS01{
//BFS01	switch (nByteAnz) {
//BFS01		case 0: { BYTE n;   rIn>>n; rVal=n; } break;
//BFS01		case 1: { UINT16 n; rIn>>n; rVal=n; } break;
//BFS01		case 3: {           rIn>>rVal;      } break;
//BFS01		default: DBG_ERROR("ImpReadValue(): Nur Bytelaengen 1, 2 oder 4 sind erlaubt!");
//BFS01	} // switch
//BFS01}

//BFS01SvStream& operator<<(SvStream& rOut, const SdrObjSurrogate& rSurro)
//BFS01{
//BFS01	BYTE nId=BYTE(rSurro.eList);
//BFS01	if (rSurro.eList==SDROBJLIST_UNKNOWN) {
//BFS01		rOut<<nId;
//BFS01	} else {
//BFS01		FASTBOOL bGrp=rSurro.nGrpLevel!=0;
//BFS01		if (bGrp) nId|=0x20; // Gruppierung
//BFS01		ULONG nMaxOrdNum=rSurro.nOrdNum;
//BFS01		unsigned i;
//BFS01		for (i=0; i<rSurro.nGrpLevel; i++) {
//BFS01			if (nMaxOrdNum<rSurro.pGrpOrdNums[i]) nMaxOrdNum=rSurro.pGrpOrdNums[i];
//BFS01		}
//BFS01		unsigned nByteAnz=0;
//BFS01		if (nMaxOrdNum>0xFF) nByteAnz++;
//BFS01		if (nMaxOrdNum>0xFFFF) nByteAnz+=2;
//BFS01		nId|=BYTE(nByteAnz<<6); // Byteanzahl an der richtigen Stelle im ID-Byte eintragen
//BFS01		rOut<<nId;
//BFS01		rSurro.ImpWriteValue(rOut,rSurro.nOrdNum,nByteAnz);
//BFS01		if (SdrIsPageKind(rSurro.eList)) { // Seitennummer schreiben
//BFS01			rOut<<rSurro.nPageNum;
//BFS01		}
//BFS01		if (bGrp) { // Gruppierung
//BFS01			rOut<<rSurro.nGrpLevel;
//BFS01			for (i=0; i<rSurro.nGrpLevel; i++) {
//BFS01				rSurro.ImpWriteValue(rOut,rSurro.pGrpOrdNums[i],nByteAnz);
//BFS01			}
//BFS01		}
//BFS01	}
//BFS01	return rOut;
//BFS01}

//BFS01void SdrObjSurrogate::ImpRead(SvStream& rIn)
//BFS01{
//BFS01	BYTE nId;
//BFS01	rIn>>nId;
//BFS01	eList=SdrObjListKind(nId & 0x1F);
//BFS01	if (eList!=SDROBJLIST_UNKNOWN) {
//BFS01		FASTBOOL bGrp=(nId & 0x20)!=0;      // Id-Byte
//BFS01		unsigned nByteAnz=(nId & 0xC0)>>6;  // aufschluesseln
//BFS01		ImpReadValue(rIn,nOrdNum,nByteAnz); // Ordnungsnummer des Objekts
//BFS01		if (SdrIsPageKind(eList)) { // Seitennummer schreiben
//BFS01			rIn>>nPageNum;
//BFS01		}
//BFS01		if (bGrp) { // Gruppierung
//BFS01			rIn>>nGrpLevel;
//BFS01			pGrpOrdNums=new UINT32[nGrpLevel];
//BFS01			for (unsigned i=0; i<nGrpLevel; i++) {
//BFS01				ImpReadValue(rIn,pGrpOrdNums[i],nByteAnz);
//BFS01			}
//BFS01		}
//BFS01	}
//BFS01}

//BFS01void SdrObjSurrogate::ImpFindObj()
//BFS01{
//BFS01	if (eList!=SDROBJLIST_UNKNOWN) {
//BFS01		switch (eList) {
//BFS01			case SDROBJLIST_SAMEPAGE: case SDROBJLIST_SAMELIST: {
//BFS01				if (pRefObj!=NULL) {
//BFS01					pPage=pRefObj->GetPage();
//BFS01					if (eList==SDROBJLIST_SAMELIST) {
//BFS01						pRootList=pRefObj->GetObjList();
//BFS01						if (pRootList==NULL) {
//BFS01							DBG_ERROR("SdrObjSurrogate::ImpFindObj(): eList=SDROBJLIST_SAMELIST, pRefObj hat jedoch keine ObjList");
//BFS01							return;
//BFS01						}
//BFS01					} else {
//BFS01						if (pPage!=NULL) {
//BFS01							pRootList=pPage;
//BFS01						} else {
//BFS01							DBG_ERROR("SdrObjSurrogate::ImpFindObj(): eList=SDROBJLIST_SAMEPAGE, pRefObj hat jedoch keine Page");
//BFS01							return;
//BFS01						}
//BFS01					}
//BFS01				} else {
//BFS01					DBG_ERROR("SdrObjSurrogate::ImpFindObj(): Relatives Surrogat benoetigt Referenzobjekt");
//BFS01					return;
//BFS01				}
//BFS01			} break;
//BFS01			case SDROBJLIST_DRAWPAGE: pPage=pModel->GetPage(nPageNum); pRootList=pPage; break;
//BFS01			case SDROBJLIST_MASTERPAGE: pPage=pModel->GetMasterPage(nPageNum); pRootList=pPage; break;
//BFS01			case SDROBJLIST_VIRTOBJECTS: {
//BFS01				DBG_ERROR("SdrObjSurrogate::ImpFindObj(): Persistente virtuelle Objekte in dieser Version nicht verfuegbar");
//BFS01				return;
//BFS01			} break;
//BFS01			case SDROBJLIST_SYMBOLTABLE: {
//BFS01				DBG_ERROR("SdrObjSurrogate::ImpFindObj(): Symbole in dieser Version nicht verfuegbar");
//BFS01				return;
//BFS01			} break;
//BFS01			default: {
//BFS01				DBG_ERROR("SdrObjSurrogate::ImpFindObj(): Unbekannter oder unsinniger Objektlistentyp");
//BFS01				return;
//BFS01			}
//BFS01		} // switch
//BFS01		pList=pRootList;
//BFS01		for (unsigned i=0; i<nGrpLevel; i++) {
//BFS01			SdrObject* pO=pList->GetObj(pGrpOrdNums[i]);
//BFS01			if (pO!=NULL) {
//BFS01				pList=pO->GetSubList();
//BFS01				if (pList==NULL) {
//BFS01					DBG_ERROR("SdrObjSurrogate::ImpFindObj(): Objekt ist kein Gruppenobjekt");
//BFS01					return;
//BFS01				}
//BFS01			} else {
//BFS01				DBG_ERROR("SdrObjSurrogate::ImpFindObj(): Gruppenobjekt nicht gefunden");
//BFS01				return;
//BFS01			}
//BFS01		}
//BFS01		pObj=pList->GetObj(nOrdNum);
//BFS01		DBG_ASSERT(pObj!=NULL,"SdrObjSurrogate::ImpFindObj(): Zielobjekt nicht gefunden");
//BFS01	}
//BFS01}

//BFS01SdrObject* SdrObjSurrogate::GetObject()
//BFS01{
//BFS01	if (pObj==NULL && eList!=SDROBJLIST_UNKNOWN) ImpFindObj();
//BFS01	return pObj;
//BFS01}


