#*************************************************************************
#
#   OpenOffice.org - a multi-platform office productivity suite
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.11 $
#
#   last change: $Author: rt $ $Date: 2005/09/09 11:51:04 $
#
#   The Contents of this file are made available subject to
#   the terms of GNU Lesser General Public License Version 2.1.
#
#
#     GNU Lesser General Public License Version 2.1
#     =============================================
#     Copyright 2005 by Sun Microsystems, Inc.
#     901 San Antonio Road, Palo Alto, CA 94303, USA
#
#     This library is free software; you can redistribute it and/or
#     modify it under the terms of the GNU Lesser General Public
#     License version 2.1, as published by the Free Software Foundation.
#
#     This library is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#     MA  02111-1307  USA
#
#*************************************************************************

PRJ=..$/..

PRJNAME=vcl
TARGET=ex
.INCLUDE :	$(PRJ)$/util$/makefile.pmk

# --- Settings -----------------------------------------------------

.INCLUDE :	svpre.mk
.INCLUDE :	settings.mk
.INCLUDE :	sv.mk
.INCLUDE :  $(PRJ)$/util$/makefile2.pmk


UNOUCRDEP=	$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=	$(SOLARBINDIR)$/applicat.rdb
UNOUCROUT=	$(OUT)$/inc$/ex
INCPRE+=	$(UNOUCROUT)

.IF "$(TF_SVDATA)"==""

UNOTYPES=\
	com.sun.star.datatransfer.clipboard.XClipboardEx		\
	com.sun.star.datatransfer.XTransferable					\
	com.sun.star.datatransfer.XTransferableEx				\
	com.sun.star.datatransfer.clipboard.XClipboardOwner		\
	com.sun.star.datatransfer.clipboard.XClipboardListener	\
	com.sun.star.datatransfer.clipboard.XClipboardNotifier	\
	com.sun.star.datatransfer.XTransferDataAccess			\
	com.sun.star.lang.IllegalArgumentException				\
	com.sun.star.uno.TypeClass								\
	com.sun.star.uno.XWeak									




.IF "$(COM)"=="ICC"
CDEFS+=-D_STD_NO_NAMESPACE -D_VOS_NO_NAMESPACE -D_UNO_NO_NAMESPACE
.ENDIF

.IF "$(GUI)"=="UNX"
CDEFS+=-D_WEX_DLLNAME=\"dll://$(DLLPRE)sex$(UPD)$(DLLPOSTFIX)$(DLLPOST)\"
.ELSE
.IF "$(GUI)"=="MAC"
CDEFS+=-D_WEX_DLLNAME="dll://wex$(UPD)$(DLLPOSTFIX).dll"
.ELSE
.IF "$(GUI)"=="OS2"
CDEFS+=-D_WEX_DLLNAME=\"dll://sex$(UPD)$(DLLPOSTFIX)\"
.ELSE
CDEFS+=-D_WEX_DLLNAME=\"dll://sex$(UPD)$(DLLPOSTFIX).dll\"
.ENDIF
.ENDIF
.ENDIF

# --- Files --------------------------------------------------------

SLOFILES=  $(SLO)$/exchange.obj \
			$(SLO)$/drag.obj		\
			$(SLO)$/clip.obj		\
			$(SLO)$/transfer.obj	\
			$(SLO)$/unoex.obj

.IF "$(GUI)"=="MAC"
CXXFILES+=macex.cxx
SLOFILES+=$(SLO)$/macex.obj
.ENDIF

EXCEPTIONSFILES=$(SLO)$/drag.obj \
				$(SLO)$/clip.obj \
				$(SLO)$/unoex.obj

.ENDIF

# --- Targets ------------------------------------------------------

.INCLUDE :	target.mk

.INCLUDE :	$(PRJ)$/util/$/target.pmk

